############################################################################
#    Copyright (C) 2005 by Ian Monroe                                      #
#    ian@monroe.nu                                                         #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################
require 'setup.rb'
require 'Korundum'


# class UserPrefs < KDE::ConfigSkeleton
# 	include Singleton
# 	attr_reader :saveURL
# 	def initialize(*k)
# 		super(*k)
# 		@saveURL = QT::String.new
# 		setConfigForm('PlaylistConfig')
# 		addItemString('saveURL', @saveURL, '/home')
# 	end
# end

# class PrefDialog < KDE:ConfigDialog
# 	def initialize(parent)
# 		prefs = UserPrefs.new
# 		super(parent, 'Settings', prefs, KDE::DialogBase.Plain, 10)
# 		prefs.readConfig
# 	end
# end

class AmarokWindow < ConfigForm
    def okButton_clicked()
		prefs = PlaylistConfig.instance
    	prefs.setConfig(kcfg_saveURL.url, 
            rateInput.value,
            maxListInput.value,
            xPosInput.value,
            yPosInput.value,
            xSizeInput.value,
            ySizeInput.value,
#             @desktopWindow.x, 
#             @desktopWindow.y, 
#             @desktopWindow.size.width, 
#             @desktopWindow.size.height,
            enableDesktopCheck.isChecked)
		prefs.save
		hide() #QT::Widget.hide()
	end

    def enableDesktopCheck_toggled(*k)
        @desktopSettings.each { |c| 
            c.enabled = @enableDesktopCheck.checked? 
            puts "#{c} is #{c.enabled?}"
            } 
            puts 'hello'
    end   
# 	def queryClose()
# 		hide()
# 		return false
# 	end
#     def show
#         super
# #         if PlaylistConfig.instance.showDWindow
# #             @desktopWindow.hide
# #             KDE::Win.setType(@desktopWindow.winId(), KDE::NET.Normal)
# #             @desktopWindow.clearWFlags(@desktopWindow.getWFlags)
# #             @desktopWindow.setWFlags(Qt::WType_Dialog)
# #             @desktopWindow.show
# #         end
#     end
#     def hideEvent(e)
# #         if PlaylistConfig.instance.showDWindow
# #             KDE::Win.setType(@desktopWindow.winId(), KDE::NET.Toolbar)
# #             @desktopWindow.setWFlags(Qt.WStyle_Customize |
# #                 Qt.WStyle_NoBorder  |
# #                 Qt.WDestructiveClose)
# #         end
#     end
    def initialize(*k)
        super(*k)
        @desktopSettings = [xPosInput, yPosInput, xSizeInput, ySizeInput,xLabel1,xLabel2,posLabel,posLabel_2]
        enableDesktopCheck_toggled()
        #@desktopWindow = desktopWindow
		prefs = PlaylistConfig.instance
		#kcfg_saveURL.setURL(prefs.saveURL)
		#puts @kcfg_saveURL
		kcfg_saveURL.URL = prefs.saveURL
		#puts @rateInput
		#puts "updateMin: #{prefs.updateMin}"
		#rateInput.setValue(1)		
		rateInput.value = prefs.updateMin
		#puts "maxItems: #{prefs.maxItems}"
		maxListInput.value = prefs.maxItems
        enableDesktopCheck.checked = prefs.showDWindow
        xPosInput.value = prefs.posX
        yPosInput.value = prefs.posY
        xSizeInput.value = prefs.sizeX
        ySizeInput.value = prefs.sizeY
        xPosInput.inputMethodEnabled = true
        puts "inputMethodEnabled #{xPosInput.isInputMethodEnabled}"
		#prefs.app.setTopWidget(self)
    end

end
